#include <iostream>
#include <vector>

using namespace std;
int main()
{
    int t, n, k,p;
    cin >> t >> n >> k;
    vector<int> a(n);
    for (size_t i = 0; i < n; i++)
    {
        cin >> p;
        a[i] = p;
    }
    if (k > 0 && k % 2 == n % 2)
    {
        cout << "DA" << '\n';
        if (t == 1)
        {
            int r = (n - 1) / 2 + k;
            for (size_t i = r; i <= n; i++)
            {
                cout << i << " ";
            }
            for (int i = r - 1; i >= 1; i--)
            {
                cout << i<< " ";
            }
        }
    }
    else
    {
        cout << "NE";
    }
}